package com.gmail.dddeeefff.Boutique;


import java.io.File;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import java.util.logging.Logger;

import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.Location;
import org.bukkit.World;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.plugin.java.JavaPlugin;

public class Boutique extends JavaPlugin
	{
	Logger log;
	
	
	public void onEnable()
		{
		createDataDirectory();
		File configFile = new File(this.getDataFolder(), "config.yml");
		if (!configFile.exists()) {saveDefaultConfig();}

		log = this.getLogger();
		log.info("Boutique enabled");
		}
	
	/* ************   DUMMY DATA *************************** 
	ChatColor cNonPlayerError = ChatColor.YELLOW;                            //Colour returned when non-player tries to execute a command they should not execute
    ChatColor cUserError = ChatColor.YELLOW;                                         //Colour returned when user tries something they cannot do
    ChatColor cPluginError = ChatColor.RED;                                          //Colour returned when plugin goes wrong
    ChatColor cSucessfulExecutionFeedback = ChatColor.GREEN;         //Colour returned when user successfully executes a command
    ChatColor cAdvice = ChatColor.AQUA;                                                      //Colour returned for an advice message
    ChatColor cListHeadShop = ChatColor.DARK_BLUE;                           //Colour used for the header of the Shop field in /shoplist
    ChatColor cListHeadDescription = ChatColor.DARK_GRAY;            //Colour used for the header of the Description field in /shoplist
    ChatColor cListEntryShop = ChatColor.BLUE;                                       //Colour used for the entries of the Shop field in /shoplist
    ChatColor cListEntryDescription = ChatColor.GRAY;                        //Colour used for the entries of the Description field in /shoplist
    ChatColor cListbar = ChatColor.WHITE;                                            //Colour used for the bar in /shoplist
    ChatColor cCommandCommand = ChatColor.BLUE;                                      //Colour used for the the Commands in /shopcommands
    ChatColor cCommandBar = ChatColor.WHITE;                         //Colour used for the divider bar between commands in /shopcommands
    
    //String tableAddress = "jdbc:mysql://localhost:3306/Boutique";
	//String mysqlUsername = "root";
	//String mysqlPassword = "";
    /* ***************************************************** */

	public void onDisable(){log.info("Boutique disabled");}
	
	private boolean createDataDirectory() {
	    File file = this.getDataFolder();
	    if (!file.isDirectory()){
	        if (!file.mkdirs()) {
	            // failed to create the non existent directory, so failed
	            return false;
	        }
	    }
	    return true;
	}
	
	/* ******** Begin Miscellaneous methods ******************* */
	
	// Check whether a person is online
    private boolean checkPlayerIsOnline(String checkee)
    	{
    	Player other = (Bukkit.getServer().getPlayer(checkee));
            if (other == null) {return false;}
            else {return true;}
    	}
    
    // Get the colour required for a message from the config
    private String messageColour(String colour)
    	{
    	colour = colour.replaceFirst("c", "colour");
    	colour = getConfig().getString(colour);
		
		//I'm sure this could be done quicker
		int counter = 0;
		String[] colourTypes =
			{
			"black", "dark_blue", "dark_green", "dark_aqua", "dark_red", "dark_purple",
			"gold", "gray", "dark_gray", "blue", "green", "aqua", "red",
			"light_purple", "yellow", "white"
			};
		String[] colourReturned = 
			{
			ChatColor.BLACK + "", ChatColor.DARK_BLUE + "", ChatColor.DARK_GREEN + "", ChatColor.DARK_AQUA + "", ChatColor.DARK_RED + "", ChatColor.DARK_PURPLE + "",
			ChatColor.GOLD + "", ChatColor.GRAY + "", ChatColor.DARK_GRAY + "", ChatColor.BLUE + "", ChatColor.GREEN + "", ChatColor.AQUA + "", ChatColor.RED + "",
			ChatColor.LIGHT_PURPLE + "", ChatColor.YELLOW + "", ChatColor.WHITE + ""
			};
		String colourTwo = "";
		while (counter < 16)
			{
			if (colour.equals(colourTypes[counter]))
				{
				colourTwo = colourReturned[counter];
				}
			counter++;
			}

		return colourTwo;
	}
	
  	/* ********** Begin Database stuff *****************/
	
	//connect to database method
	private Connection connectDB() throws ClassNotFoundException, SQLException
		{
		Class.forName("com.mysql.jdbc.Driver");
		
		final FileConfiguration config = this.getConfig();
	    String tableAddress = "jdbc:mysql://" + config.getString("database_address") + ":" + config.getString("database_port") + "/Boutique";
		String mysqlUsername = config.getString("database_user");
		String mysqlPassword = config.getString("database_password");
		
		return DriverManager.getConnection(tableAddress, mysqlUsername, mysqlPassword);
		}

	//Make a query.  //NOTSAFE. Be careful passing queries to this method
	private ResultSet getQuery(String query) throws SQLException, ClassNotFoundException
		{
		PreparedStatement statement = connectDB().prepareStatement(query);
		ResultSet result = statement.executeQuery();
		return result;
		}
	
	//Manipulate Data - insert //NOTSAFE - VULNERABLE. Be careful passing queries to this method
	private void manipulateDB(String sql) throws SQLException, ClassNotFoundException
		{
		PreparedStatement statement = connectDB().prepareStatement(sql);
		statement.executeUpdate();
		}
	
	//This checks for a given person in the database //SAFE - no variables are injected into a MySQL command
	private Boolean checkShopExists(String person) throws SQLException, Exception 
		{
		ResultSet result = getQuery("SELECT shop FROM Shops");
		while (result.next())
			{if (result.getString(1).equalsIgnoreCase(person) ==  true){return true;}}
		return false;
		}

	// Check if a given person's shop is open. Returns null (if that's the right word) if shop doesn't exist  //SAFE - no variables are injected into a MySQL command
	private Boolean checkShopIsOpen(String person) throws SQLException, ClassNotFoundException
		{
		ResultSet result = getQuery("SELECT shop FROM Shops WHERE status = '1'");
		while (result.next())
		{if (result.getString(1).equalsIgnoreCase(person) ==  true){return true;}}
		return false;
		}
	
	// Get location data for person in database //Possibly safe - Bukkit's getName() function should not return an unsafe string
	private Location getTPData(Player to, Player from) throws SQLException, ClassNotFoundException
		{
		ResultSet result = getQuery("SELECT worldname,locationx,locationy,locationz,yaw,pitch FROM Shops WHERE lower(Shops.shop) = lower('" + to.getName() + "')");
		result.next();
		
		// Create dummy location data based on the sender of the command. This is probably the best way to do this, except for 
		Location location = from.getLocation();
					
		//Get World type associated with world name from database
		World world = Bukkit.getServer().getWorld(result.getString(1));
		// Set location to have the appropriate variables
		location.setWorld(world);
		location.setX(result.getDouble(2));
		location.setY(result.getDouble(3));
		location.setZ(result.getDouble(4));
		location.setYaw(result.getFloat(5));
		location.setPitch(result.getFloat(6));

		return location;
		}
	// End Database stuff
	
/* ************** BEGIN COMMANDS STUFF******************* */ 
	public boolean onCommand(CommandSender sender, Command cmd, String label, String[] args)
    	{
		Player player = null;
		if (sender instanceof Player) {player = (Player) sender;}
	 
    	//String originatorName = player.getName();
		
/* BEGIN COMMANDS */
		
		///shop
    	if (cmd.getName().equalsIgnoreCase("shop")) 
       		{
    		if (player == null) {sender.sendMessage(messageColour("cNonPlayerError") +"non players can't go to their shop - they can't even have one");
    		return true;} 
    		else
    			{
    			if (args.length > 1)
        			{
    				return false;
        			} 
				try
					{
					if (checkShopExists(player.getName()) == false)	{sender.sendMessage(messageColour("cUserError") +"You need to register a shop with /shopregister [DECRIPTION]");}
					else
						{
						if (checkShopIsOpen(player.getName()) == false){sender.sendMessage(messageColour("cUserError") + "You need to open your shop with /shopopen to be able to teleport there");}
						else
							{
							player.teleport(getTPData(player, player));
							}
						}
					}
				catch (SQLException e)
					{
					sender.sendMessage(messageColour("cPluginError") + "Error S1 - Please report this to an operator");
					e.printStackTrace();
					}
				catch (Exception e)
					{
					sender.sendMessage(messageColour("cPluginError") + "Error E1 - Please report this to an operator");
					e.printStackTrace();
					}
					
				}
    		return true;
        	}
    	
    	///shopregister //Description has not been fully protected. It needs to be properly added and have string replaced cancelled characters.
        else if (cmd.getName().equalsIgnoreCase("shopregister")) 
    		{
        	if (player == null) 
        		{
        		sender.sendMessage(messageColour("cNonPlayerError") + "non players can't register a shop");
        		return true;
        		}
        		
        	else {

					try {
						double locationx = player.getLocation().getX();
						double locationy = player.getLocation().getY();
						double locationz = player.getLocation().getZ();
						float yaw = player.getLocation().getYaw();
						float pitch = player.getLocation().getPitch();
						World world = player.getLocation().getWorld();
						String worldname = world.getName();
						
						// Combine Arguments into one string
						StringBuilder sb = new StringBuilder();
						for(int i=0; i<args.length; i++){
						    if(i != 0)
						        sb.append(' ');
						    sb.append(args[i]);
						}
						String description = sb.toString();
						//End combine
																		
						if (checkShopExists(player.getName()) == false)
							{
							PreparedStatement statement = connectDB().prepareStatement(
								"INSERT INTO Shops" +
								"(shop,description,status,locationx,locationy,locationz,yaw,pitch,worldname)" +
								" VALUES " +
								"('" + player.getName() +"', ?, '0', '" + locationx + "', '" + locationy + "', '" + locationz + "', '" + yaw + "', '" + pitch + "', '" + worldname + "')"
								);
							statement.setString(1, description);
							statement.executeUpdate();
							
							sender.sendMessage(messageColour("cSucessfulExecutionFeedback") + "Registered your shop");
							sender.sendMessage(messageColour("cAdvice") +"You must open your shop with /shopopen to appear in /shoplist and to activate teleportation");
							return true;
							}
						
						else
							{
							PreparedStatement statement = connectDB().prepareStatement(
									"UPDATE Shops " +
									"SET" + 
									"  description=?" +
									", status='0'" +
									", locationx='" + locationx + "'" +
									", locationy='" + locationy + "'" +
									", locationz='" + locationz + "'" +
									", yaw='" + yaw + "'" +
									", pitch='" + pitch + "'" +
									", worldname='" + worldname + "'" +
									" WHERE shop='"+ player.getName() + "'");
								statement.setString(1, description);
								statement.executeUpdate();

							sender.sendMessage(messageColour("cSucessfulExecutionFeedback") + "Updated your shop." + messageColour("cAdvice") + " Your shop is currently closed");
							return true;
							}
					} catch (SQLException e) {
						sender.sendMessage(messageColour("cPluginError") + "Error S2 - Please report this to an operator");
						e.printStackTrace();
					} catch (Exception e) {
						sender.sendMessage(messageColour("cPluginError") + "Error E2 - Please report this to an operator");
						e.printStackTrace();
					}
					
					
        		}
        			
        	
        	return true;
    		}
    	
    	//shopopen
        else if (cmd.getName().equalsIgnoreCase("shopopen"))
    		{
        	if (player == null)
        		{
        		sender.sendMessage(messageColour("cNonPlayerError") + "non players can't open shop");
        		}
        	else
        		{
				try
					{
					if (checkShopExists(player.getName()) == false)
						{
						sender.sendMessage(messageColour("cUserError") + "You don't have a shop to open." + messageColour("cAdvice") + "Register a shop with /shopregister to open a shop");
						}
					else
						{
						if (checkShopIsOpen(player.getName()) == false)
							{
							manipulateDB("UPDATE Shops SET status='1' WHERE shop = '" + player.getName() + "'");
							sender.sendMessage(messageColour("cSucessfulExecutionFeedback") + "Opened shop succesfully. Shop now listed in /shoplist");
							sender.sendMessage(messageColour("cAdvice") + "Use /shopclose to temporarily remove yourself from the /shoplist");
							}
						else
							{
							sender.sendMessage(messageColour("cUserError") + "You eejit! Shop is already open.");
							}
						}
					}
				catch (SQLException e)
					{
					sender.sendMessage(messageColour("cPluginError") + "Error S3 - Please report this to an operator");
					}
				catch (Exception e)
					{
					sender.sendMessage(messageColour("cPluginError") + "Error E3 - Please report this to an operator");
					}
    			}
        	return true;
    		}

	///shopclose
        else if (cmd.getName().equalsIgnoreCase("shopclose")) 
     		{
         	if (player == null)
         		{
         		sender.sendMessage(messageColour("cNonPlayerError") + "non players can't close a shop");
         		return true;
         		}
         	else
         		{
				try
					{
					if (checkShopExists(player.getName()) == false)
						{
						sender.sendMessage(messageColour("cUserError") + "You don't have a shop to close");
						}
					else
						{

						if (checkShopIsOpen(player.getName()) == false)
							{
							sender.sendMessage(messageColour("cUserError") + "Hyuck, Imma gone tried to close my already closed shop");
							}
						else
							{
							manipulateDB("UPDATE Shops SET status='0' WHERE shop='" + player.getName() + "'");
							sender.sendMessage(messageColour("cSucessfulExecutionFeedback") + "Shop closed. " + messageColour("cAdvice") + "You can open shop again with /shopopen any time");
							}
						}
					}
				catch (SQLException e)
					{
					sender.sendMessage(messageColour("cPluginError") + "Error S4 - Please report this to an operator");
					e.printStackTrace();
					}
				catch (Exception e)
					{
					sender.sendMessage(messageColour("cPluginError") + "Error E4 - Please report this to an operator");
					e.printStackTrace();
					}
       			}
         	return true;
     		}
    	
		//shoplist    	
    	else if (cmd.getName().equalsIgnoreCase("shoplist"))
    		{
       		try 
      			{
               	sender.sendMessage(messageColour("cListHeadShop") + "SHOP NAME" + messageColour("cListbar") + " | " + messageColour("cListHeadDescription") + "DESCRIPTION:");
       			ResultSet result = getQuery("SELECT shop,description FROM Shops WHERE status = '1'");
       			while(result.next())
       				{
       				if (checkPlayerIsOnline(result.getString(1)) == true)
       					{sender.sendMessage (messageColour("cListEntryShop") + result.getString(1) + messageColour("cListbar") + " | " + messageColour("cListEntryDescription") + result.getString(2));}		
       				}
      			}
			catch (SQLException e)
				{
				sender.sendMessage(messageColour("cPluginError") + "Error S5 - Please report this to an operator");
				e.printStackTrace();
				}
       		catch (Exception e)
       			{
       			sender.sendMessage(messageColour("cPluginError") + "Error E5 - Please report this to an operator");
       			e.printStackTrace();
       			}
			
        	return true;
    		}
    	
    	///shopgo        
        else if (cmd.getName().equalsIgnoreCase("shopgo")) 
    		{
        	if (player == null)
        		{
        		sender.sendMessage(messageColour("cNonPlayerError") + "non players can't teleport to a shop");
        		return true;
        		}
        	else if (args.length > 1)
        		{
        		sender.sendMessage(messageColour("cUserError") + "Too many arguments!");
        		return false;
        		} 
        	else if (args.length < 1)
        		{
        		sender.sendMessage(messageColour("cUserError") + "Not enough arguments!");
        		return false;
        		}
        	else if (args.length == 1)
        		{
        		if (args[0].length() > 16)
        			{
        			sender.sendMessage(messageColour("cUserError") + "Not a valid minecraft name - too many characters");
        			return false;
        			}
        		else if (args[0].matches("[a-zA-Z0-9_]*") == false)
        			{sender.sendMessage(messageColour("cUserError") + "Not a valid minecraft name - contained a non-alphanumeric character that wasn't _");
        			return false;
        			}
        		else if (args[0].matches("[a-zA-Z0-9_]*") == true)
        			{
        			String otherPersonName = args[0];
        			Player otherPlayer = Bukkit.getServer().getPlayer(otherPersonName);
        			try 
        				{
        				if (checkShopExists(otherPersonName) == false)
        					{
        					sender.sendMessage(messageColour("cUserError") + "'" + otherPersonName + "' does not have a shop or does not exist");
        					return true;
							}
        				else
        					{
        					if (checkShopIsOpen(otherPersonName) == false)
        						{
        						sender.sendMessage(messageColour("cUserError") + otherPersonName + "'s shop is not open. You can't teleport to a closed shop");
        						return true;
								}
        					else
        						{
        						if (checkPlayerIsOnline(otherPersonName) == true)
        							{
        							player.teleport(getTPData(otherPlayer, player));
        							if (otherPersonName == player.getName()) {sender.sendMessage(messageColour("cAdvice") + "/shop will teleport you to your shop as well");}
        							return true;
									}
        						else if (checkPlayerIsOnline(otherPersonName) == false)
        							{
        							sender.sendMessage(messageColour("cUserError") + otherPersonName + " is not online - you can't teleport to their shop");
        							return true;
									}
        						else 
        							{ //This should never happen unless Bukkit IPA is buggy. Or I am.
        							sender.sendMessage (messageColour("cPluginError") + "Error U1 - Please report this to an operator");
        							return false;
									}
								}
							}
						}
        			catch (SQLException e)
        				{
        				sender.sendMessage(messageColour("cPluginError") + "Error S6 - Please report this to an operator");
        				e.printStackTrace();
						}
        			catch (Exception e)
        				{
        				sender.sendMessage(messageColour("cPluginError") + "Error E6 - Please report this to an operator");
        				e.printStackTrace();
						}
        			}
        		}
        	else
        		{ //This should never happen unless Bukkit IPA is buggy. Or I am.
        		sender.sendMessage(messageColour("cPluginError") + "Error U2 - Please report this to an operator");
        		return false;
        		}
        
    		}

 	 ///shopcommands
        else if (cmd.getName().equalsIgnoreCase("shopcommands")) 
    		{
    		sender.sendMessage(messageColour("cCommandCommand") +"shop" + messageColour("cCommandBar") + " | " + messageColour("cCommandCommand") + "shopregister" + messageColour("cCommandBar") + " | " + messageColour("cCommandCommand") + "shopopen" + messageColour("cCommandBar") + " | " + messageColour("cCommandCommand") + "shopclose" + messageColour("cCommandBar") + " | " + messageColour("cCommandCommand") + "shoplist" + messageColour("cCommandBar") + " | " + messageColour("cCommandCommand") + "shopgo" + messageColour("cCommandBar") + " | " + messageColour("cCommandCommand") + "shopcommands");
    		sender.sendMessage(messageColour("cAdvice") + "Examples: register your shop with /shopregister, list shops with /shoplist and go to one with /shopgo");
    		return true;
    		}

    	return false;
		}
	}

